require 'tofu/tofulet'
require 'drb/drb'

def setup_yourapp(monolithic=true)
  if monolithic
    require 'yourapp'
    Tofu::Bartender.new(YourTofuSession)
  else
    DRbObject.new(nil, 'druby://localhost:7642')
  end
end

def setup_rw_edit(monolithic = true)
  if monolithic
    require 'rw-edit'
    Tofu::Bartender.new(RWikiTofuSession)
  else
    DRbObject.new(nil, 'druby://localhost:7643')
  end
end

def main(monolithic=true)
  DRb.start_service

  logger = WEBrick::Log::new($stderr, WEBrick::Log::DEBUG)

  s = WEBrick::HTTPServer.new(:Port => 2001,
			      :AddressFamily => Socket::AF_INET,
			      :BindAddress => ENV['HOSTNAME'],
			      :Logger => logger)

  bartender = setup_yourapp(monolithic)
  s.mount("/div", WEBrick::Tofulet, bartender)

  bartender = setup_rw_edit(monolithic)
  s.mount('/edit', WEBrick::Tofulet, bartender)

  trap("INT"){ s.shutdown }
  s.start
end

main(ARGV.shift)



